# Written by Mads Engelund, 2017, http://espeem.com
import unittest

from CalcTroll.ASEUtils.Atoms import Atoms
from CalcTroll.Core.Test.Case import CalcTrollTestCase
from CalcTroll.API import view


from CalcTroll.Plugins.Systems.TerminatedRibbon import     TerminatedArmchairRibbon
from CalcTroll.Plugins.Systems.Diamond001.DanglingBonds import DimerWire
from .LiftOff import LiftOff


class LiftOffTest(CalcTrollTestCase):
    def notestConstruction(self):
        parameters = dict(
                on_parameters=dict(
                    free_layers=6*3,
                    bound_layers=0,
                    electrode_layers=6,
                    ),
                slab_parameters=dict(
                    vectors=((2,0),(0, 4)),
                    free_layers=1,
                    bound_layers=1,
                    ),
                )
        ribbon = TerminatedArmchairRibbon(5)
        slab = DimerWire('Ge')

        system = LiftOff(
                polymer=ribbon,
                slab=slab,
                parameters=parameters,
                )

        atoms = system.atoms()
        expected = [[-6.72712033591, -8.00162033591, -1.485        ],
                    [-6.20612033591, -8.00162033591, 0.0           ],
                    [-1.2745       , -8.00162033591, -1.485        ],
                    [1.2745        , -8.00162033591, -1.485        ],
                    [6.20612033591 , -8.00162033591, 0.0           ],
                    [6.72712033591 , -8.00162033591, -1.485        ],
                    [-8.00162033591, -7.23583662487, -5.12362862804],
                    [-4.00081016795, -7.23583662487, -5.12362862804],
                    [0.0           , -7.23583662487, -5.12362862804],
                    [4.00081016795 , -7.23583662487, -5.12362862804],
                    [-8.00162033591, -6.00121525193, -4.1865       ],
                    [-6.00121525193, -6.00121525193, -2.772        ],
                    [-4.00081016795, -6.00121525193, -4.1865       ],
                    [-2.00040508398, -6.00121525193, -2.772        ],
                    [0.0           , -6.00121525193, -4.1865       ],
                    [2.00040508398 , -6.00121525193, -2.772        ],
                    [4.00081016795 , -6.00121525193, -4.1865       ],
                    [6.00121525193 , -6.00121525193, -2.772        ],
                    [-8.00162033591, -4.76659387899, -5.12362862804],
                    [-4.00081016795, -4.76659387899, -5.12362862804],
                    [0.0           , -4.76659387899, -5.12362862804],
                    [4.00081016795 , -4.76659387899, -5.12362862804],
                    [-6.72712033591, -4.00081016795, -1.485        ],
                    [-6.20612033591, -4.00081016795, 0.0           ],
                    [-1.2745       , -4.00081016795, -1.485        ],
                    [1.2745        , -4.00081016795, -1.485        ],
                    [6.20612033591 , -4.00081016795, 0.0           ],
                    [6.72712033591 , -4.00081016795, -1.485        ],
                    [-8.00162033591, -3.23502645691, -5.12362862804],
                    [-4.00081016795, -3.23502645691, -5.12362862804],
                    [0.0           , -3.23502645691, -5.12362862804],
                    [4.00081016795 , -3.23502645691, -5.12362862804],
                    [-8.00162033591, -2.00040508398, -4.1865       ],
                    [-6.00121525193, -2.00040508398, -2.772        ],
                    [-4.00081016795, -2.00040508398, -4.1865       ],
                    [-2.00040508398, -2.00040508398, -2.772        ],
                    [0.0           , -2.00040508398, -4.1865       ],
                    [2.00040508398 , -2.00040508398, -2.772        ],
                    [4.00081016795 , -2.00040508398, -4.1865       ],
                    [6.00121525193 , -2.00040508398, -2.772        ],
                    [-8.00162033591, -0.76578371104, -5.12362862804],
                    [-4.00081016795, -0.76578371104, -5.12362862804],
                    [0.0           , -0.76578371104, -5.12362862804],
                    [4.00081016795 , -0.76578371104, -5.12362862804],
                    [-6.72712033591, 0.0           , -1.485        ],
                    [-6.20612033591, 0.0           , 0.0           ],
                    [-1.2745       , 0.0           , -1.485        ],
                    [1.2745        , 0.0           , -1.085        ],
                    [6.20612033591 , 0.0           , 0.0           ],
                    [6.72712033591 , 0.0           , -1.485        ],
                    [-8.00162033591, 0.76578371104 , -5.12362862804],
                    [-4.00081016795, 0.76578371104 , -5.12362862804],
                    [0.0           , 0.76578371104 , -5.12362862804],
                    [4.00081016795 , 0.76578371104 , -5.12362862804],
                    [-8.00162033591, 2.00040508398 , -4.1865       ],
                    [-6.00121525193, 2.00040508398 , -2.772        ],
                    [-4.00081016795, 2.00040508398 , -4.1865       ],
                    [-2.00040508398, 2.00040508398 , -2.772        ],
                    [0.0           , 2.00040508398 , -4.1865       ],
                    [2.00040508398 , 2.00040508398 , -2.772        ],
                    [4.00081016795 , 2.00040508398 , -4.1865       ],
                    [6.00121525193 , 2.00040508398 , -2.772        ],
                    [-8.00162033591, 3.23502645691 , -5.12362862804],
                    [-4.00081016795, 3.23502645691 , -5.12362862804],
                    [0.0           , 3.23502645691 , -5.12362862804],
                    [4.00081016795 , 3.23502645691 , -5.12362862804],
                    [-6.72712033591, 4.00081016795 , -1.485        ],
                    [-6.20612033591, 4.00081016795 , 0.0           ],
                    [-1.2745       , 4.00081016795 , -1.485        ],
                    [1.2745        , 4.00081016795 , -1.485        ],
                    [6.20612033591 , 4.00081016795 , 0.0           ],
                    [6.72712033591 , 4.00081016795 , -1.485        ],
                    [-8.00162033591, 4.76659387899 , -5.12362862804],
                    [-4.00081016795, 4.76659387899 , -5.12362862804],
                    [0.0           , 4.76659387899 , -5.12362862804],
                    [4.00081016795 , 4.76659387899 , -5.12362862804],
                    [-8.00162033591, 6.00121525193 , -4.1865       ],
                    [-6.00121525193, 6.00121525193 , -2.772        ],
                    [-4.00081016795, 6.00121525193 , -4.1865       ],
                    [-2.00040508398, 6.00121525193 , -2.772        ],
                    [0.0           , 6.00121525193 , -4.1865       ],
                    [2.00040508398 , 6.00121525193 , -2.772        ],
                    [4.00081016795 , 6.00121525193 , -4.1865       ],
                    [6.00121525193 , 6.00121525193 , -2.772        ],
                    [-8.00162033591, 7.23583662487 , -5.12362862804],
                    [-4.00081016795, 7.23583662487 , -5.12362862804],
                    [0.0           , 7.23583662487 , -5.12362862804],
                    [4.00081016795 , 7.23583662487 , -5.12362862804],
                    [-1.22975607337, 12.5787729734 , 11.2988420077 ],
                    [1.22975607337 , 12.5787729734 , 11.2988420077 ],
                    [-1.22975607337, 12.137351534  , 10.3022241708 ],
                    [1.22975607337 , 12.137351534  , 10.3022241708 ],
                    [-3.40347983687, 12.0705308573 , 10.1513600029 ],
                    [3.40347983687 , 12.0705308573 , 10.1513600029 ],
                    [-2.45951214675, 11.8495355815 , 9.65317790617 ],
                    [0.0           , 11.8495355815 , 9.65317790617 ],
                    [2.45951214675 , 11.8495355815 , 9.65317790617 ],
                    [-2.45951214675, 11.1960385075 , 8.39328207512 ],
                    [0.0           , 11.1960385075 , 8.39328207512 ],
                    [2.45951214675 , 11.1960385075 , 8.39328207512 ],
                    [-3.40347983687, 10.9093083626 , 7.92985211962 ],
                    [3.40347983687 , 10.9093083626 , 7.92985211962 ],
                    [-1.22975607337, 10.8186955756 , 7.79196101272 ],
                    [1.22975607337 , 10.8186955756 , 7.79196101272 ],
                    [-1.22975607337, 9.96844393613 , 6.65553324098 ],
                    [1.22975607337 , 9.96844393613 , 6.65553324098 ],
                    [-3.40347983687, 9.86173331924 , 6.52968619588 ],
                    [3.40347983687 , 9.86173331924 , 6.52968619588 ],
                    [-2.45951214675, 9.49807076295 , 6.12381547161 ],
                    [0.0           , 9.49807076295 , 6.12381547161 ],
                    [2.45951214675 , 9.49807076295 , 6.12381547161 ],
                    [-2.45951214675, 8.47383902328 , 5.14129561212 ],
                    [0.0           , 8.47383902328 , 5.14129561212 ],
                    [2.45951214675 , 8.47383902328 , 5.14129561212 ],
                    [-3.40347983687, 8.05320737436 , 4.7948125453  ],
                    [3.40347983687 , 8.05320737436 , 4.7948125453  ],
                    [-1.22975607337, 7.9230348171  , 4.69342349337 ],
                    [1.22975607337 , 7.9230348171  , 4.69342349337 ],
                    [-1.22975607337, 6.75225759676 , 3.89112888962 ],
                    [1.22975607337 , 6.75225759676 , 3.89112888962 ],
                    [-3.40347983687, 6.61072030307 , 3.80632423756 ],
                    [3.40347983687 , 6.61072030307 , 3.80632423756 ],
                    [-2.45951214675, 6.13577595604 , 3.53909892647 ],
                    [0.0           , 6.13577595604 , 3.53909892647 ],
                    [2.45951214675 , 6.13577595604 , 3.53909892647 ],
                    [-2.45951214675, 4.84981317716 , 2.93851948778 ],
                    [0.0           , 4.84981317716 , 2.93851948778 ],
                    [2.45951214675 , 4.84981317716 , 2.93851948778 ],
                    [-3.40347983687, 4.34004565038 , 2.74585769005 ],
                    [3.40347983687 , 4.34004565038 , 2.74585769005 ],
                    [-1.22975607337, 4.18416690715 , 2.69176099951 ],
                    [1.22975607337 , 4.18416690715 , 2.69176099951 ],
                    [-1.22975607337, 2.81746380139 , 2.30898358177 ],
                    [1.22975607337 , 2.81746380139 , 2.30898358177 ],
                    [-3.40347983687, 2.65616290469 , 2.27424663826 ],
                    [3.40347983687 , 2.65616290469 , 2.27424663826 ],
                    [-2.45951214675, 2.12048260942 , 2.17410613239 ],
                    [0.0           , 2.12048260942 , 2.17410613239 ],
                    [2.45951214675 , 2.12048260942 , 2.17410613239 ],
                    [-2.45951214675, 0.70964708321 , 2.01938364263 ],
                    [0.0           , 0.70964708321 , 2.01938364263 ],
                    [2.45951214675 , 0.70964708321 , 2.01938364263 ],
                    [-3.40347983687, 0.164995569931, 2.00104710133 ],
                    [3.40347983687 , 0.164995569931, 2.00104710133 ],
                    [-1.22975607337, 0.0           , 2.0           ],
                    [1.22975607337 , 0.0           , 2.0           ],
                    [-1.22975607337, -1.08872329994, 2.04566938911 ],
                    [1.22975607337 , -1.08872329994, 2.04566938911 ]]

        e_symbols = ['Ge', 'H', 'Ge', 'Ge', 'H', 'Ge', 'H', 'H', 'H',
                     'H', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge',
                     'H', 'H', 'H', 'H', 'Ge', 'H', 'Ge', 'Ge', 'H',
                     'Ge', 'H', 'H', 'H', 'H', 'Ge', 'Ge', 'Ge', 'Ge',
                     'Ge', 'Ge', 'Ge', 'Ge', 'H', 'H', 'H', 'H', 'Ge',
                     'H', 'Ge', 'Ge', 'H', 'Ge', 'H', 'H', 'H', 'H',
                     'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge', 'Ge',
                     'H', 'H', 'H', 'H', 'Ge', 'H', 'Ge', 'Ge', 'H',
                     'Ge', 'H', 'H', 'H', 'H', 'Ge', 'Ge', 'Ge', 'Ge',
                     'Ge', 'Ge', 'Ge', 'Ge', 'H', 'H', 'H', 'H', 'H',
                     'H', 'C', 'C', 'H', 'H', 'C', 'C', 'C', 'C', 'C',
                     'C', 'H', 'H', 'C', 'C', 'C', 'C', 'H', 'H', 'C',
                     'C', 'C', 'C', 'C', 'C', 'H', 'H', 'C', 'C', 'C',
                     'C', 'H', 'H', 'C', 'C', 'C', 'C', 'C', 'C', 'H',
                     'H', 'C', 'C', 'C', 'C', 'H', 'H', 'C', 'C', 'C',
                     'C', 'C', 'C', 'H', 'H', 'C', 'C', 'H', 'H']
        e_atoms = Atoms(symbols=e_symbols, positions=expected)
        self.assertAtomsEqual(e_atoms, atoms)


if __name__=='__main__':
    unittest.main()
